Subject: Re: /srv/bzr/emacs/trunk r111878: * lisp/replace.el (read-regexp): Let-bind `default' to the first

From: Jambunathan K <[email-masked]>
Date: Wed, 06 Mar 2013 23:33:08 +0530

Juri Linkov <[email-masked]> writes:

>> The question was one of how `read-regexp' should behave?
>>
>> If (car DEFAULTS) is nil should it offer (car SUGGESTIONS) as a default
>> or offer an empty string for default.
>
> As bug#13805 indicates, `read-regexp' should return an empty string
> when the caller specifies that (car DEFAULTS) is nil.

I think I overlooked the bug number in your commit.  Otherwise, I
wouldn't have triggered this discussion in first place.  Sorry.

>
> This is like what `read-from-minibuffer' does.  But note that
> `read-from-minibuffer' is even more strict, and doesn't return
> the default value even if it's specified, i.e. typing RET
> after evaluating
>
> (read-from-minibuffer "Prompt: " nil nil nil nil "default")
>
> returns an empty string instead of the default value.
> This is because its arg DEFAULT-VALUE acts more like
> a suggestion available for M-n whose values should not be
> returned for empty input.